#ifndef JACKPROCESSOR_H
#define JACKPROCESSOR_H

#include <stdio.h>
#include <stdlib.h>
#include <QtCore/QObject>
#include <QtCore/QMutex>
#include <QtCore/QSemaphore>
#include <QtCore/QWaitCondition>
#include <jack/jack.h>
#include "model.h"

class JackProcessor : public QObject
{
  Q_OBJECT
  
  private:
    Model *model;
    jack_client_t *jackHandle;
    jack_port_t *jackOut[2];
    jack_port_t *jackMidi;
    bool sustain;
    
  private:
    static int jack_static_callback(jack_nframes_t nframes, void *arg);
    int jack_callback(jack_nframes_t nframes);

  public:
    JackProcessor(Model *p_model, QObject* parent=0);
    ~JackProcessor();
    int initJack();

  signals:
    void MIDI_controlEvent(int, unsigned char, unsigned int, int, int);

};
  
#endif
